codeforces 732D Exams 二分搜索 贪心

D. Exams
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasiliy has an exam period which will continue for n days. He has to pass exams on m subjects. Subjects are numbered from 1 to m.

About every day we know exam for which one of m subjects can be passed on that day. Perhaps, some day you can't pass any exam. It is not allowed to pass more than one exam on any day.

On each day Vasiliy can either pass the exam of that day (it takes the whole day) or prepare all day for some exam or have a rest.

About each subject Vasiliy know a number ai — the number of days he should prepare to pass the exam number i. Vasiliy can switch subjects while preparing for exams, it is not necessary to prepare continuously during ai days for the exam number i. He can mix the order of preparation for exams in any way.

Your task is to determine the minimum number of days in which Vasiliy can pass all exams, or determine that it is impossible. Each exam should be passed exactly one time.

Input

The first line contains two integers n and m (1 ≤ n, m ≤ 105) — the number of days in the exam period and the number of subjects.

The second line contains n integers d1, d2, ..., dn (0 ≤ di ≤ m), where di is the number of subject, the exam of which can be passed on the day number i. If di equals 0, it is not allowed to pass any exams on the day number i.

The third line contains m positive integers a1, a2, ..., am (1 ≤ ai ≤ 105), where ai is the number of days that are needed to prepare before passing the exam on the subject i.

Output

Print one integer — the minimum number of days in which Vasiliy can pass all exams. If it is impossible, print -1.

Examples
input
7 2
0 1 0 2 1 0 2
2 1
output
5
input
10 3
0 0 1 2 3 0 2 0 1 2
1 1 4
output
9
input
5 1
1 1 1 1 1
5
output
-1
Note

In the first example Vasiliy can behave as follows. On the first and the second day he can prepare for the exam number 1 and pass it on the fifth day, prepare for the exam number 2 on the third day and pass it on the fourth day.

In the second example Vasiliy should prepare for the exam number 3 during the first four days and pass it on the fifth day. Then on the sixth day he should prepare for the exam number 2 and then pass it on the seventh day. After that he needs to prepare for the exam number 1 on the eighth day and pass it on the ninth day.

In the third example Vasiliy can't pass the only exam because he hasn't anough time to prepare for it.

题意:

某人要考试 。。。干。。。明天再写。。。

继续。。。某人要考试,现在总共有n天m门考试,在这n天中有几天是可以考特定的科目的,题中的d数组会给出

比如

0 0 1 2 3 0 2 0 1 2

表示在第3、9天可以考科目1。 4、7、10天可以考科目2.。。。标号为0的那天可以用来复习,如果不选择当天考试的话那天也可以用来复习

但是每门考试都需要复习一定的天数ai才能考好,对复习天数的要求是不用连续,只要累计达到ai即可

主人公想花最少的天数每门都考好,求最少天数,如果根本不可能输出-1

比赛的时候还以为是动态规划什么的。。。。因为时间剩不多了,越写越觉得靠谱。。。然而写到后面又越来越不靠谱。。。。。

居然是二分搜索答案!真是没有想到,我感觉这个能想到的话就是要先确定我们能判断给在给定的这些考试要求的情况下t天是否可能完成要求。对于t可以确定其是否可能才能在1~n内做二分搜索啊!

假定现在有t天,我感觉这个采取的策略就是贪心。。。虽然不知道是否合适这样称呼。肯定每门科目都参加最后的那一场,那么前面就会有尽可能多的时间给自己复习,如果即使这样还是不能复习完的话,就不可能啦

能够确定t天能否达到要求后,就能在1~n天内二分了

说难也不难。。。加油啊!

代码:

#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>
#include <set>
using namespace std;
const int maxn = 1e5 +10;
int n,m,need;
int a[maxn],d[maxn];
bool Bsearch(int k){
    int i;
    bool vis[maxn]={false};
    memset(vis, false, sizeof(vis));
    int free = k-m,last = need;
    for(i=k;i>=1;i--){
        if(!d[i]||vis[d[i]]){
            free--;
            continue;
        }
        if(free>=last){
            vis[d[i]]=true;
            last -= a[d[i]];
        }else{
            return false;
        }
    }
    return (free==0);
}
int main(){
    int i,j;
    scanf("%d%d",&n,&m);
    for(i=1;i<=n;i++){
        scanf("%d",&d[i]);
    }
    need=0;
    for(i=1;i<=m;i++){
        scanf("%d",&a[i]);
        need+=a[i];
    }
    int left=1,right=n,middle;
    while(left<right){
        middle =(left+right)/2;
        if(Bsearch(middle)){
            right = middle;
        }else{
            left = middle +1;
        }
    }
    if(Bsearch(right)){
        printf("%d\n",right);
    }else{
        printf("-1\n");
    }
}
//10 3
//0 0 1 2 3 0 2 0 1 2
//1 1 4


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值